%{
#include <string.h>
#include "y.tab.h"

	/* other includes */

int lineno = 1;
void yyerror(char *s);
%}

%%

SELECT		{ return SELECT; }
UNION		{ return UNION; }
JOIN		{ return JOIN; }
INTERSECT	{ return INTERSECT; }
DIFFERENCE		{ return DIFFERENCE; }
MINUS		{ return DIFFERENCE; }
DIVIDE		{ return DIVIDE; }
PROJECT		{ return PROJECT; }
PRODUCT		{ return PRODUCT; }
NOT			{ return NOT; }
OR			{ return OR; }
AND			{ return AND; }

"="		|
"<>"	|
"<"		|
">"		|
"<="	|
">="		{ return COMPARISON; }

[-+*/:(),.;]	{ return yytext[0]; }

	/* names */
[A-Za-z][A-Za-z0-9]*	{ return NAME; }

	/* numbers */
[0-9]+	|
[0-9]+"."[0-9]* |
"."[0-9]*	{ return INTNUM; }

	/* strings */

'[^'\n]' {
	int c=input();
	unput(c); 
	if (c!='\'')
		return STRING;
	else
		yymore();
}

	/* whitespace */
\n	lineno++;

[ \t\r]+	; 
	
	/* comment */
"--".* ; 

	/*.	yyerror("invalid character); */

%%

void yyerror(char *s) {

	printf("%d: %s at %s\n",lineno, s, yytext);
}

main(int ac, char **av)
{
	if (ac>1 && (yyin=fopen(av[1], "r"))==NULL) {
		perror(av[1]);
		exit(1);
	}

	if(!yyparse())
		printf("Algebra parse worked\n");
	else
		printf("Algebra parse failed\n");
}
